// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/api/intime/os_init.c $
// $Rev: 43206 $
// $Date: 2018-07-08 17:03:14 -0500 (Sun, 08 Jul 2018) $

// INtime: API Library: source file

#include "main.h"



// variables ******************************************************************

os_api_global_t	os_api_global;



//*****************************************************************************
// Return Values:
//	0  = success
//	<0 = failure, value is -errno or -INtime error code
//	>0 = never returned
int os_api_init(void)
{
	static	int	busy	= 1;

	int	ret;

#ifdef __OS_VALIDATE__

	os_validate();				// Validate data types and macros, then exit.

#endif

	if (os_api_global.initialized == 0)
	{
		memset(&os_api_global, 0, sizeof(os_api_global));
		os_api_global.initialized	= 1;

		ret	= os_sem_create(&os_api_global.sem);

		if (ret)
		{
			os_api_global.initialized	= 0;
		}
		else
		{
			busy	= 0;
		}
	}
	else if (busy)
	{
		ret	= -EBUSY;
	}
	else
	{
		ret	= 0;
	}

	return(ret);
}


