// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/include/16aio_utils.h $
// $Rev: 43209 $
// $Date: 2018-07-08 17:26:09 -0500 (Sun, 08 Jul 2018) $

// 16AIO: Utilities: header file

#ifndef __16AIO_UTILS_H__
#define __16AIO_UTILS_H__

#include "16aio_api.h"
#include "gsc_utils.h"



// prototypes *****************************************************************

// API utility services

int	aio_close_util			(int fd, int index, int verbose);
int aio_init_util			(int verbose);
int aio_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	aio_open_util			(int device, int share, int index, int verbose, int* fd);
int	aio_read_util			(int fd, int index, int verbose, void* dst, size_t size);
int	aio_write_util			(int fd, int index, int verbose, const void* src, size_t size);

// IOCTL utility services

int	aio_ai_buf_clear		(int fd, int index, int verbose);								// AIO_IOCTL_AI_BUF_CLEAR
int	aio_ai_buf_thr_lvl		(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_AI_BUF_THR_LVL
int	aio_ai_buf_thr_sts		(int fd, int index, int verbose, s32* get);						// AIO_IOCTL_AI_BUF_THR_STS
int	aio_ai_mode				(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_AI_MODE
int	aio_ai_scan_1_chan		(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_AI_SCAN_1_CHAN
int	aio_ai_scan_clk_src		(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_AI_SCAN_CLK_SRC
int	aio_ai_scan_size		(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_AI_SCAN_SIZE
int	aio_ai_sync				(int fd, int index, int verbose);								// AIO_IOCTL_AI_SYNC
int	aio_ao_buf_clear		(int fd, int index, int verbose);								// AIO_IOCTL_AO_BUF_CLEAR
int	aio_ao_buf_thr_lvl		(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_AO_BUF_THR_LVL
int	aio_ao_buf_thr_sts		(int fd, int index, int verbose, s32* get);						// AIO_IOCTL_AO_BUF_THR_STS
int	aio_ao_burst_clk_src	(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_AO_BURST_CLK_SRC
int	aio_ao_burst_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_AO_BURST_ENABLE
int	aio_ao_clk_src			(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_AO_CLK_SRC
int	aio_ao_looping			(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_AO_LOOPING
int	aio_ao_sync				(int fd, int index, int verbose);								// AIO_IOCTL_AO_SYNC
int	aio_ao_timing			(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_AO_TIMING
int	aio_auto_cal_sts		(int fd, int index, int verbose, s32* get);						// AIO_IOCTL_AUTO_CAL_STS
int	aio_auto_calibrate		(int fd, int index, int verbose);								// AIO_IOCTL_AUTO_CALIBRATE
int	aio_aux_read			(int fd, int index, int verbose, s32* get);						// AIO_IOCTL_AUX_READ
int	aio_aux_write			(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_AUX_WRITE
int	aio_data_format			(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_DATA_FORMAT
int	aio_dio_dir_out			(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_DIO_DIR_OUT
int	aio_dio_read			(int fd, int index, int verbose, s32* get);						// AIO_IOCTL_DIO_READ
int	aio_dio_write			(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_DIO_WRITE
int	aio_ext_sync_src		(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_EXT_SYNC_SRC
int	aio_initialize			(int fd, int index, int verbose);								// AIO_IOCTL_INITIALIZE
int	aio_irq0_sel			(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_IRQ0_SEL
int	aio_irq1_sel			(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_IRQ1_SEL
int	aio_irq2_sel			(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_IRQ2_SEL
int	aio_query				(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_QUERY
int	aio_range				(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_RANGE
int aio_reg_mod				(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);	// AIO_IOCTL_REG_MOD
int	aio_reg_read			(int fd, int index, int verbose, u32 reg, u32* value);			// AIO_IOCTL_REG_READ
int	aio_reg_write			(int fd, int index, int verbose, u32 reg, u32 value);			// AIO_IOCTL_REG_WRITE
int	aio_rga_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_RGA_ENABLE
int	aio_rga_nrate			(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_RGA_NRATE
int	aio_rgb_clk_src			(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_RGB_CLK_SRC
int	aio_rgb_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_RGB_ENABLE
int	aio_rgb_nrate			(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_RGB_NRATE
int	aio_rx_io_abort			(int fd, int index, int verbose, s32* get);						// AIO_IOCTL_RX_IO_ABORT
int	aio_rx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_RX_IO_MODE
int	aio_rx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_RX_IO_TIMEOUT
int	aio_tx_io_abort			(int fd, int index, int verbose, s32* get);						// AIO_IOCTL_TX_IO_ABORT
int	aio_tx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_TX_IO_MODE
int	aio_tx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// AIO_IOCTL_TX_IO_TIMEOUT
int	aio_wait_cancel			(int fd, int index, int verbose, gsc_wait_t* wait);				// AIO_IOCTL_WAIT_CANCEL
int	aio_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);				// AIO_IOCTL_WAIT_EVENT
int	aio_wait_status			(int fd, int index, int verbose, gsc_wait_t* wait);				// AIO_IOCTL_WAIT_STATUS

// Auxiliary utility services

int aio_config_ai			(int fd, int index, int verbose, s32 fsamp);
int	aio_config_ao			(int fd, int index, int verbose, s32 fsamp);
int	aio_fburst_ao_report	(int fd, int index, int verbose, s32* get);
int	aio_fsamp_ai_compute	(int fd, int index, int verbose, s32 fsamp, s32* nrate, double* rate);
int	aio_fsamp_ai_report		(int fd, int index, int verbose, int chan, s32* fsamp);
int	aio_fsamp_ai_report_all	(int fd, int index, int verbose, s32* fsamp);
int	aio_fsamp_ao_compute	(int fd, int index, int verbose, s32 fsamp, s32* nrate, double* rate);
int aio_fsamp_ao_report		(int fd, int index, int verbose, int chan, s32* fsamp);
int aio_fsamp_ao_report_all	(int fd, int index, int verbose, s32* fsamp);
int aio_id_device			(int fd, int index, int verbose);

int	aio_count_boards		(int verbose, s32* get);
int	aio_fsamp_ai_get		(int fd, int index, int verbose, int chan, s32* get);
int	aio_reg_list			(int fd, int detail);

const gsc_reg_def_t*		aio_reg_get_def_id(u32 reg);
const gsc_reg_def_t*		aio_reg_get_def_index(int index);
const char*					aio_reg_get_desc(u32 reg);
const char*					aio_reg_get_name(u32 reg);



#endif
