// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/utils/intime/os_utils.h $
// $Rev: 43207 $
// $Date: 2018-07-08 17:04:20 -0500 (Sun, 08 Jul 2018) $

// INtime: Utility: header file

#ifndef __OS_UTILS_H__
#define __OS_UTILS_H__

#include <stdio.h>
#include <string.h>

#include "os_common.h"



// data types *****************************************************************

typedef	struct
{
	RTHANDLE	handle;
} os_sem_t;

typedef struct
{
	RTHANDLE	handle;
	char		name[64];
} os_thread_t;



// prototypes *****************************************************************

int		os_count_boards(	int		verbose,
							int*	qty,
							int		(*dev_open)(int device, int share, int* fd),
							int		(*dev_read)(int fd, void* dst, size_t size),
							int		(*dev_close)(int fd));

int		os_id_driver(	int	(*dev_open)(int index, int share, int* fd),
						int	(*dev_read)(int fd, void* dst, size_t size),
						int	(*dev_close)(int fd));
void	os_id_host(void);

int		os_sem_create(os_sem_t* sem);
int		os_sem_create_qty(os_sem_t* sem, int cap, int put);
int		os_sem_destroy(os_sem_t* sem);
int		os_sem_lock(os_sem_t* sem);
int		os_sem_unlock(os_sem_t* sem);

int		os_thread_create(os_thread_t* thread, const char* name, int (*function)(void* arg), void* arg);
int		os_thread_destroy(os_thread_t* thread);

void	os_sleep_ms(int ms);

size_t	os_time_delta_ms(void);



#endif
