// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/auxin/auxio.c $
// $Rev: 43221 $
// $Date: 2018-07-08 17:47:48 -0500 (Sun, 08 Jul 2018) $

// 16AIO: Sample Application: source file

#include "main.h"



/******************************************************************************
*
*	Function:	_dev_aux_in
*
*	Purpose:
*
*		Read from the Auxiliary Input input.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _dev_aux_in(int fd)
{
	int	errs;
	int	ret;
	u32	val;

	ret		= aio_ioctl(fd, AIO_IOCTL_AUX_READ, &val);
	errs	= ret ? 1 : 0;
	printf("%d", (int) val);
	return(errs);
}



/******************************************************************************
*
*	Function:	aux_in
*
*	Purpose:
*
*		Perform an Auxiliary Input test.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

int aux_in(int fd)
{
	int	errs	= 0;
	int	i;

	for (;;)
	{
		errs	+= aio_initialize(fd, -1, 1);

		if (errs)
			break;

		printf("    Aux In\n");
		printf("    0\n");
		printf("    =\n");

		for (i = 0; i < 16; i++)
		{
			printf("    ");
			errs	+= _dev_aux_in(fd);
			printf("\n");
			gsc_time_sleep_ms(250);
		}

		gsc_label_level_inc();
		errs	+= aio_initialize(fd, -1, 0);
		gsc_label("Status");
		printf("%s\n", errs ? "FAIL <---" : "PASS");
		gsc_label_level_dec();
		break;
	}

	return(errs);
}



