// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/auxout/auxio.c $
// $Rev: 43222 $
// $Date: 2018-07-08 17:48:00 -0500 (Sun, 08 Jul 2018) $

// 16AIO: Sample Application: source file

#include "main.h"



/******************************************************************************
*
*	Function:	_dev_aux_out
*
*	Purpose:
*
*		Write to the Auxiliary Output.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*		data	The data to write.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _dev_aux_out(int fd, u16 data)
{
	int	errs;
	int	ret;
	s32	val		= data;

	printf("    %d\n", (int) data );
	ret		= aio_ioctl(fd, AIO_IOCTL_AUX_WRITE, &val);
	errs	= ret ? 1 : 0;
	gsc_time_sleep_ms(250);
	return(errs);
}



/******************************************************************************
*
*	Function:	aux_out
*
*	Purpose:
*
*		Perform a Auxiliary Output test.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

int aux_out(int fd)
{
	int	errs	= 0;

	for (;;)	// A convenience loop
	{
		errs	+= aio_initialize(fd, -1, 1);

		if (errs)
			break;

		printf("    Aux Out\n");
		printf("    0\n");
		printf("    =\n");

		errs	+= _dev_aux_out(fd, 0);

		errs	+= _dev_aux_out(fd, 1);
		errs	+= _dev_aux_out(fd, 1);
		errs	+= _dev_aux_out(fd, 1);
		errs	+= _dev_aux_out(fd, 0);

		errs	+= _dev_aux_out(fd, 1);
		errs	+= _dev_aux_out(fd, 1);
		errs	+= _dev_aux_out(fd, 0);
		errs	+= _dev_aux_out(fd, 1);

		errs	+= _dev_aux_out(fd, 0);
		errs	+= _dev_aux_out(fd, 1);
		errs	+= _dev_aux_out(fd, 1);
		errs	+= _dev_aux_out(fd, 0);

		errs	+= _dev_aux_out(fd, 1);
		errs	+= _dev_aux_out(fd, 1);
		errs	+= _dev_aux_out(fd, 1);
		errs	+= _dev_aux_out(fd, 0);

		errs	+= _dev_aux_out(fd, 1);
		errs	+= _dev_aux_out(fd, 1);
		errs	+= _dev_aux_out(fd, 1);
		errs	+= _dev_aux_out(fd, 1);

		errs	+= _dev_aux_out(fd, 0);

		gsc_label_level_inc();
		errs	+= aio_initialize(fd, -1, 0);
		gsc_label("Status");
		printf("%s\n", errs ? "FAIL <---" : "PASS");
		gsc_label_level_dec();
		break;
	}

	return(errs);
}



