// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/sbtest/ai_buf_clear.c $
// $Rev: 43231 $
// $Date: 2018-07-08 17:50:09 -0500 (Sun, 08 Jul 2018) $

// 16AIO: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_BUF_CLEAR,
			/* arg		*/	0,
			/* reg		*/	AIO_GSC_IBCR,
			/* mask		*/	0x8000,
			/* value	*/	0x0000
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= aio_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list);

	errs	+= service_ioctl_set_reg_list(fd, list);

	errs	+= aio_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	static const service_data_t	list[]	=
	{
		// Force a buffer overflow.

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGA_NRATE,
			/* arg		*/	100,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGA_ENABLE,
			/* arg		*/	AIO_GEN_ENABLE_YES,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_BUF_THR_LVL,
			/* arg		*/	100,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{				// Wait for data reception.
			/* service	*/	SERVICE_SLEEP_MS,
			/* cmd		*/	0,
			/* arg		*/	50,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{				// Verify that the threshold bit is set.
			/* service	*/	SERVICE_REG_TEST,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AIO_GSC_IBCR,
			/* mask		*/	0x10000,
			/* value	*/	0x10000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGA_ENABLE,
			/* arg		*/	AIO_GEN_ENABLE_NO,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},

		// Clear the buffer and verify the results.

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_BUF_CLEAR,
			/* arg		*/	0,
			/* reg		*/	AIO_GSC_IBCR,
			/* mask		*/	0x10000,
			/* value	*/	0x00000
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= aio_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list);

	errs	+= aio_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	ai_buf_clear_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AIO_IOCTL_AI_BUF_CLEAR.
*
*	Arguments:
*
*		fd		The handle for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai_buf_clear_test(int fd)
{
	int	errs	= 0;

	gsc_label("AIO_IOCTL_AI_BUF_CLEAR");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


