// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/sbtest/ai_buf_thr_sts.c $
// $Rev: 43231 $
// $Date: 2018-07-08 17:50:09 -0500 (Sun, 08 Jul 2018) $

// 16AIO: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	// This is tested below.
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	static const service_data_t	list_1[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_SIZE,
			/* arg		*/	AIO_AI_SCAN_SIZE_SINGLE,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGA_NRATE,
			/* arg		*/	80,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGA_ENABLE,
			/* arg		*/	AIO_GEN_ENABLE_YES,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_BUF_CLEAR,
			/* arg		*/	0,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{					// Verify that the threshold bit is clear.
			/* service	*/	SERVICE_REG_TEST,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AIO_GSC_IBCR,
			/* mask		*/	0x10000,
			/* value	*/	0x00000
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	list_2[]	=
	{
		{
			/* service	*/	SERVICE_SLEEP,
			/* cmd		*/	0,
			/* arg		*/	1,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{					// Verify that the threshold bit is set.
			/* service	*/	SERVICE_REG_TEST,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AIO_GSC_IBCR,
			/* mask		*/	0x10000,
			/* value	*/	0x10000
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	list_3[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGA_ENABLE,
			/* arg		*/	AIO_GEN_ENABLE_NO,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_BUF_THR_LVL,
			/* arg		*/	0x7FFE,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{					// Verify that the threshold bit is set.
			/* service	*/	SERVICE_REG_TEST,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AIO_GSC_IBCR,
			/* mask		*/	0x10000,
			/* value	*/	0x10000
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	list_4[]	=
	{
		{					// Remove one sample from the Rx FIFO.
			/* service	*/	SERVICE_REG_TEST,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AIO_GSC_IDBR,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	list_5[]	=
	{
		{					// Verify that the threshold bit is CLEAR.
			/* service	*/	SERVICE_REG_TEST,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AIO_GSC_IBCR,
			/* mask		*/	0x10000,
			/* value	*/	0x00000
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	int	i;
	int	ret;
	u32	sts;

	errs	+= aio_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list_1);
	// Verify that the threshold status is CLEAR.
	ret	= aio_ioctl(fd, AIO_IOCTL_AI_BUF_THR_STS, &sts);

	if (ret)
	{
		errs++;
	}
	else if (sts != AIO_AI_BUF_THR_STS_CLEAR)
	{
			errs++;
			printf(	"FAIL <---  (%d. expected %ld, got %ld)\n",
					__LINE__,
					(long) AIO_AI_BUF_THR_STS_CLEAR,
					(long) sts);
	}

	errs	+= service_ioctl_set_reg_list(fd, list_2);
	// Verify that the threshold status is SET.
	ret	= aio_ioctl(fd, AIO_IOCTL_AI_BUF_THR_STS, &sts);

	if (ret)
	{
		errs++;
	}
	else if (sts != AIO_AI_BUF_THR_STS_SET)
	{
			errs++;
			printf(	"FAIL <---  (%d. expected %ld, got %ld)\n",
					__LINE__,
					(long) AIO_AI_BUF_THR_STS_SET,
					(long) sts);
	}

	errs	+= service_ioctl_set_reg_list(fd, list_3);
	// Verify that the threshold status is still SET.
	ret	= aio_ioctl(fd, AIO_IOCTL_AI_BUF_THR_STS, &sts);

	if (ret)
	{
		errs++;
	}
	else if (sts != AIO_AI_BUF_THR_STS_SET)
	{
			errs++;
			printf(	"FAIL <---  (%d. expected %ld, got %ld)\n",
					__LINE__,
					(long) AIO_AI_BUF_THR_STS_SET,
					(long) sts);
	}

	// Remove some data (empty the intermediate buffer).

	for (i = 0; (i < 256) && (errs == 0); i++)
		errs	+= service_ioctl_set_reg_list(fd, list_4);

	errs	+= service_ioctl_set_reg_list(fd, list_5);
	// Verify that the threshold status is CLEAR.
	ret	= aio_ioctl(fd, AIO_IOCTL_AI_BUF_THR_STS, &sts);

	if (ret)
	{
		errs++;
	}
	else if (sts != AIO_AI_BUF_THR_STS_CLEAR)
	{
			errs++;
			printf(	"FAIL <---  (%d. expected %ld, got %ld)\n",
					__LINE__,
					(long) AIO_AI_BUF_THR_STS_CLEAR,
					(long) sts);
	}

	errs	+= aio_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	ai_buf_thr_sts_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AIO_IOCTL_AI_BUF_THR_STS.
*
*	Arguments:
*
*		fd		The handle for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai_buf_thr_sts_test(int fd)
{
	int	errs	= 0;

	gsc_label("AIO_IOCTL_AI_BUF_THR_STS");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


