// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/sbtest/ai_scan_size.c $
// $Rev: 43231 $
// $Date: 2018-07-08 17:50:09 -0500 (Sun, 08 Jul 2018) $

// 16AIO: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_SIZE,
			/* arg		*/	AIO_AI_SCAN_SIZE_SINGLE,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x20800,
			/* value	*/	0x00800
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_SIZE,
			/* arg		*/	AIO_AI_SCAN_SIZE_0_1,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x20000,
			/* value	*/	0x20000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_SIZE,
			/* arg		*/	AIO_AI_SCAN_SIZE_0_3,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x20803,
			/* value	*/	0x00000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_SIZE,
			/* arg		*/	AIO_AI_SCAN_SIZE_0_7,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x20803,
			/* value	*/	0x00001
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_SIZE,
			/* arg		*/	AIO_AI_SCAN_SIZE_0_15,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x20803,
			/* value	*/	0x00002
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_SIZE,
			/* arg		*/	AIO_AI_SCAN_SIZE_0_31,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x20803,
			/* value	*/	0x00003
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= aio_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= aio_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	static service_data_t	list[]	=
	{
		{	// 0
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_MODE,
			/* arg		*/	AIO_AI_MODE_SINGLE,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{	// 1
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_SIZE,
			/* arg		*/	-1,		// set below
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{	// 2
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_CLK_SRC,
			/* arg		*/	AIO_AI_SCAN_CLK_SRC_BCR,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{	// 3
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_BUF_CLEAR,
			/* arg		*/	0,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{	// 4			wait for propogation
			/* service	*/	SERVICE_SLEEP_MS,
			/* cmd		*/	0,
			/* arg		*/	100,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{	// 5			perform a scan
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SYNC,
			/* arg		*/	0,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{	// 6			wait for propogation
			/* service	*/	SERVICE_SLEEP_MS,
			/* cmd		*/	0,
			/* arg		*/	100,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{	// 7
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_BUF_THR_LVL,
			/* arg		*/	-1,			// set below
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{	// 8
			/* service	*/	SERVICE_REG_TEST,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AIO_GSC_IBCR,
			/* mask		*/	0x10000,
			/* value	*/	0x00000
		},
		{	// 9
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_BUF_THR_LVL,
			/* arg		*/	-1,			// set below
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{	// 10
			/* service	*/	SERVICE_REG_TEST,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AIO_GSC_IBCR,
			/* mask		*/	0x10000,
			/* value	*/	0x10000
		},

		{ SERVICE_END_LIST }
	};

	static const struct
	{
		s32	option;
		int	size;
	} data[]	=
	{
		// option					size
		{ AIO_AI_SCAN_SIZE_SINGLE,	1	},
		{ AIO_AI_SCAN_SIZE_0_1,		2	},
		{ AIO_AI_SCAN_SIZE_0_3,		4	},
		{ AIO_AI_SCAN_SIZE_0_7,		8	},
		{ AIO_AI_SCAN_SIZE_0_15,	16	},
		{ AIO_AI_SCAN_SIZE_0_31,	32	},
		{ -1, 0							}
	};

	int	errs	= 0;
	int	i;

	for (i = 0; data[i].option >= 0; i++)
	{
		errs		+= aio_initialize(fd, -1, 0);

		list[1].arg	= data[i].option;
		list[7].arg	= data[i].size;
		list[9].arg	= data[i].size - 1;
		errs		+= service_ioctl_set_reg_list(fd, list);

		errs		+= aio_initialize(fd, -1, 0);
	}

	return(errs);
}



/******************************************************************************
*
*	Function:	ai_scan_size_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AIO_IOCTL_AI_SCAN_SIZE.
*
*	Arguments:
*
*		fd		The handle for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai_scan_size_test(int fd)
{
	int	errs	= 0;

	gsc_label("AIO_IOCTL_AI_SCAN_SIZE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


