// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/sbtest/auto_cal_sts.c $
// $Rev: 43231 $
// $Date: 2018-07-08 17:50:09 -0500 (Sun, 08 Jul 2018) $

// 16AIO: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	// There are no persistant bits to test.
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AUTO_CALIBRATE,
			/* arg		*/	0,
			/* reg		*/	AIO_GSC_BCR,
			/* mask		*/	0x4000,
			/* value	*/	0x4000
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	int	ret;
	s32	sts;

	errs	+= aio_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list);
	ret		= aio_ioctl(fd, AIO_IOCTL_AUTO_CAL_STS, &sts);
	errs	+= ret ? 1 : 0;

	if (sts != AIO_AUTO_CAL_STS_PASS)
	{
		errs++;
		printf("FAIL <---  (Auto Calibration did not pass)\n");
	}

	errs	+= service_ioctl_set_reg_list(fd, list);
	ret		= aio_ioctl(fd, AIO_IOCTL_AUTO_CAL_STS, &sts);
	errs	+= ret ? 1 : 0;

	if (sts != AIO_AUTO_CAL_STS_PASS)
	{
		errs++;
		printf("FAIL <---  (Auto Calibration did not pass)\n");
	}

	errs	+= aio_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	auto_cal_sts_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AIO_IOCTL_AUTO_CAL_STS.
*
*	Arguments:
*
*		fd		The handle for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int auto_cal_sts_test(int fd)
{
	int	errs	= 0;

	gsc_label("AIO_IOCTL_AUTO_CAL_STS");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


