// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/sbtest/dio_write.c $
// $Rev: 43231 $
// $Date: 2018-07-08 17:50:09 -0500 (Sun, 08 Jul 2018) $

// 16AIO: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{				// Set ports to output.
			/* service	*/	SERVICE_REG_MOD,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0xC0000,
			/* value	*/	0xC0000
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_DIO_WRITE,
			/* arg		*/	0x0000,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0000
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_DIO_WRITE,
			/* arg		*/	0x0001,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0001
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_DIO_WRITE,
			/* arg		*/	0x0002,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0002
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_DIO_WRITE,
			/* arg		*/	0x0004,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0004
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_DIO_WRITE,
			/* arg		*/	0x0008,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0008
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_DIO_WRITE,
			/* arg		*/	0x0010,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0010
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_DIO_WRITE,
			/* arg		*/	0x0020,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0020
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_DIO_WRITE,
			/* arg		*/	0x0040,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0040
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_DIO_WRITE,
			/* arg		*/	0x0080,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0080
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_DIO_WRITE,
			/* arg		*/	0x0100,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0100
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_DIO_WRITE,
			/* arg		*/	0x0200,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0200
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_DIO_WRITE,
			/* arg		*/	0x0400,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0400
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_DIO_WRITE,
			/* arg		*/	0x0800,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0800
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_DIO_WRITE,
			/* arg		*/	0x1000,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x1000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_DIO_WRITE,
			/* arg		*/	0x2000,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x2000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_DIO_WRITE,
			/* arg		*/	0x4000,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x4000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_DIO_WRITE,
			/* arg		*/	0x8000,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x8000
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_DIO_WRITE,
			/* arg		*/	0x0000,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0000
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= aio_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= aio_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// This requires additional equipment to test.
	return(0);
}



/******************************************************************************
*
*	Function:	dio_write_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AIO_IOCTL_DIO_WRITE.
*
*	Arguments:
*
*		fd		The handle for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dio_write_test(int fd)
{
	int	errs	= 0;

	gsc_label("AIO_IOCTL_DIO_WRITE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


