// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/sbtest/ext_sync_src.c $
// $Rev: 43231 $
// $Date: 2018-07-08 17:50:09 -0500 (Sun, 08 Jul 2018) $

// 16AIO: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_EXT_SYNC_SRC,
			/* arg		*/	AIO_AI_EXT_SYNC_SRC_AISC,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x300,
			/* value	*/	0x000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_EXT_SYNC_SRC,
			/* arg		*/	AIO_AI_EXT_SYNC_SRC_AOS,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x300,
			/* value	*/	0x100
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_EXT_SYNC_SRC,
			/* arg		*/	AIO_AI_EXT_SYNC_SRC_EXT,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x300,
			/* value	*/	0x200
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_EXT_SYNC_SRC,
			/* arg		*/	AIO_AI_EXT_SYNC_SRC_DISABLE,
			/* reg		*/	AIO_GSC_SSCR,
			/* mask		*/	0x300,
			/* value	*/	0x300
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= aio_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= aio_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// Additional equipment is needed to test this.
	return(0);
}



/******************************************************************************
*
*	Function:	ext_sync_src_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AIO_IOCTL_EXT_SYNC_SRC.
*
*	Arguments:
*
*		fd		The handle for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ext_sync_src_test(int fd)
{
	int	errs	= 0;

	gsc_label("AIO_IOCTL_EXT_SYNC_SRC");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


