// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/sbtest/irq1_sel.c $
// $Rev: 43231 $
// $Date: 2018-07-08 17:50:09 -0500 (Sun, 08 Jul 2018) $

// 16AIO: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_IRQ1_SEL,
			/* arg		*/	AIO_IRQ1_IDLE,
			/* reg		*/	AIO_GSC_ICR,
			/* mask		*/	0x70,
			/* value	*/	0x00
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_IRQ1_SEL,
			/* arg		*/	AIO_IRQ1_AI_BUF_THR_L2H,
			/* reg		*/	AIO_GSC_ICR,
			/* mask		*/	0x70,
			/* value	*/	0x10
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_IRQ1_SEL,
			/* arg		*/	AIO_IRQ1_AI_BUF_THR_H2L,
			/* reg		*/	AIO_GSC_ICR,
			/* mask		*/	0x70,
			/* value	*/	0x20
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= aio_initialize(fd, -1, 0);
	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= aio_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// Interrupts are tested under the Wait Event test.
	return(0);
}



/******************************************************************************
*
*	Function:	irq1_sel_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AIO_IOCTL_IRQ1_SEL.
*
*	Arguments:
*
*		fd		The handle for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int irq1_sel_test(int fd)
{
	int	errs	= 0;

	gsc_label("AIO_IOCTL_IRQ1_SEL");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


