// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/sbtest/query.c $
// $Rev: 43231 $
// $Date: 2018-07-08 17:50:09 -0500 (Sun, 08 Jul 2018) $

// 16AIO: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	// This is tested below.
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	s32	data;
	s32	count;
	int	errs	= 0;
	int	i;

	errs	= aio_query(fd, -1, 0, AIO_QUERY_COUNT, &count);

	if (count != (AIO_QUERY_COUNT + 1))
	{
		errs	= 1;
		printf(	"FAIL <---  (expected %ld, got %ld, rebuild application)\n",
				(long) AIO_QUERY_COUNT,
				(long) count);
	}
	else
	{
		for (i = 0; (errs == 0) && (i <= AIO_QUERY_COUNT); i++)
			errs	= aio_query(fd, -1, 0, i, &data);
	}

	return(errs);
}



/******************************************************************************
*
*	Function:	query_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AIO_IOCTL_QUERY.
*
*	Arguments:
*
*		fd		The handle for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int query_test(int fd)
{
	int	errs	= 0;

	gsc_label("AIO_IOCTL_QUERY");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


