// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/sbtest/rgb_nrate.c $
// $Rev: 43231 $
// $Date: 2018-07-08 17:50:09 -0500 (Sun, 08 Jul 2018) $

// 16AIO: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGB_NRATE,
			/* arg		*/	0x0050,
			/* reg		*/	AIO_GSC_RGBR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0050
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGB_NRATE,
			/* arg		*/	0x0051,
			/* reg		*/	AIO_GSC_RGBR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0051
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGB_NRATE,
			/* arg		*/	0x0052,
			/* reg		*/	AIO_GSC_RGBR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0052
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGB_NRATE,
			/* arg		*/	0x0054,
			/* reg		*/	AIO_GSC_RGBR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0054
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGB_NRATE,
			/* arg		*/	0x0058,
			/* reg		*/	AIO_GSC_RGBR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0058
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGB_NRATE,
			/* arg		*/	0x0070,
			/* reg		*/	AIO_GSC_RGBR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0070
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGB_NRATE,
			/* arg		*/	0x0080,
			/* reg		*/	AIO_GSC_RGBR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0080
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGB_NRATE,
			/* arg		*/	0x0100,
			/* reg		*/	AIO_GSC_RGBR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0100
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGB_NRATE,
			/* arg		*/	0x0200,
			/* reg		*/	AIO_GSC_RGBR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0200
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGB_NRATE,
			/* arg		*/	0x0400,
			/* reg		*/	AIO_GSC_RGBR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0400
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGB_NRATE,
			/* arg		*/	0x0800,
			/* reg		*/	AIO_GSC_RGBR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0800
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGB_NRATE,
			/* arg		*/	0x1000,
			/* reg		*/	AIO_GSC_RGBR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x1000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGB_NRATE,
			/* arg		*/	0x2000,
			/* reg		*/	AIO_GSC_RGBR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x2000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGB_NRATE,
			/* arg		*/	0x4000,
			/* reg		*/	AIO_GSC_RGBR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x4000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGB_NRATE,
			/* arg		*/	0x8000,
			/* reg		*/	AIO_GSC_RGBR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x8000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGB_NRATE,
			/* arg		*/	0x0050,
			/* reg		*/	AIO_GSC_RGBR,
			/* mask		*/	0xFFFF,
			/* value	*/	0x0050
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= aio_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= aio_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_SCAN_CLK_SRC,
			/* arg		*/	AIO_AI_SCAN_CLK_SRC_RGB,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGB_ENABLE,
			/* arg		*/	AIO_GEN_ENABLE_YES,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},

		// Test a fast rate.

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGB_NRATE,
			/* arg		*/	80,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_BUF_CLEAR,
			/* arg		*/	0,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{				// wait for propogation
			/* service	*/	SERVICE_SLEEP,
			/* cmd		*/	0,
			/* arg		*/	1,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{					// Verify that the threshold bit is set.
			/* service	*/	SERVICE_REG_TEST,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AIO_GSC_IBCR,
			/* mask		*/	0x10000,
			/* value	*/	0x10000
		},

		// Test a slow rate.

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_RGB_NRATE,
			/* arg		*/	0xFFFF,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_BUF_CLEAR,
			/* arg		*/	0,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{				// wait for propogation
			/* service	*/	SERVICE_SLEEP,
			/* cmd		*/	0,
			/* arg		*/	1,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{					// Verify that the threshold bit is clear.
			/* service	*/	SERVICE_REG_TEST,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AIO_GSC_IBCR,
			/* mask		*/	0x10000,
			/* value	*/	0x00000
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;

	errs	+= aio_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list);

	errs	+= aio_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	rgb_nrate_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AIO_IOCTL_RGB_NRATE.
*
*	Arguments:
*
*		fd		The handle for the board to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int rgb_nrate_test(int fd)
{
	int	errs	= 0;

	gsc_label("AIO_IOCTL_RGB_NRATE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


