// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/signals/signals.c $
// $Rev: 43232 $
// $Date: 2018-07-08 17:50:23 -0500 (Sun, 08 Jul 2018) $

// 16AIO: Sample Application: source file

#include "main.h"



/******************************************************************************
*
*	Function:	signals
*
*		Output the clocking signals for a period.
*
*	Arguments:
*
*		fd		The handle to the board to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int signals(int fd)
{
	int	errs	= 0;

	gsc_label("Sync Output");
	printf("\n");
	gsc_label_level_inc();

	errs	+= aio_initialize		(fd, -1, 1);
	errs	+= aio_ext_sync_src		(fd, -1, 1, AIO_AI_EXT_SYNC_SRC_AISC, NULL);
	errs	+= aio_ai_scan_clk_src	(fd, -1, 1, AIO_AI_SCAN_CLK_SRC_RGA, NULL);
	errs	+= aio_rga_nrate		(fd, -1, 1, 1200, NULL);
	errs	+= aio_rga_enable		(fd, -1, 1, AIO_GEN_ENABLE_YES, NULL);

	// Wait a bit.

	gsc_label("Waiting");
	gsc_time_sleep_ms(30000);
	printf("Done\n");

	errs	+= aio_initialize		(fd, -1, 1);
	gsc_label_level_dec();

	return(errs);
}



