// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/utils/read.c $
// $Rev: 42831 $
// $Date: 2018-05-17 17:10:52 -0500 (Thu, 17 May 2018) $

// 16AIO: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	aio_read_util
*
*	Purpose:
*
*		Implement a visual wrapper around the device read call.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	0: errors only, !0: all output
*
*		dst		The data read is placed here.
*
*		size	The voume of data to read.
*
*	Returned:
*
*		>= 0	The volume of data read.
*		< 0		The negative of the number of errors seen.
*
******************************************************************************/

int aio_read_util(int fd, int index, int verbose, void* dst, size_t size)
{
	int	ret;

	if (verbose)
		gsc_label_index("Reading", index);

	ret	= aio_read(fd, dst, size);

	if (verbose == 0)
	{
	}
	else if (ret >= 0)
	{
		printf("PASS  (%d bytes)\n", ret);
	}
	else
	{
		printf("FAIL <---  (requested %ld bytes, ret = %ld)\n", (long) size, (long) ret);
	}

	return(ret);
}


