// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/utils/util_ai_sync.c $
// $Rev: 43213 $
// $Date: 2018-07-08 17:38:25 -0500 (Sun, 08 Jul 2018) $

// 16AIO: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	aio_ai_sync
*
*	Purpose:
*
*		Provide a visual wrapper for the AIO_IOCTL_AI_SYNC service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int aio_ai_sync(int fd, int index, int verbose)
{
	int	errs;
	int	ret;
	s32	set;

	if (verbose)
		gsc_label_index("AI Sync", index);

	ret		= aio_ioctl(fd, AIO_IOCTL_AI_SYNC, &set);
	errs	= ret ? 1 : 0;


	if (verbose)
		printf("%s\n", errs ? "FAIL <---" : "PASS");

	return(errs);
}


